<cfcomponent output="false">
	<cfset prefix = right("#hash(getCurrentTemplatePath())#",55)>
	<cfset this.name = "#prefix#-katapult">
	<cfset this.applicationTimeOut = "#createTimeSpan(0,24,0,0)#">
	<cfset this.clientmanagement = "True">
	<cfset this.clientstorage = "cookie">
	<cfset this.sessionmanagement = "True">
	<cfset this.sessionTimeOut = "#createTimeSpan(0,0,20,0)#">
	<cfset this.scriptProtect = "True">
	<cfset this.setDomainCookies = "No">
		
<cffunction name="onApplicationStart" returntype="Void" output="false">
	<cfset application.starttime = NOW()>
	<cfset application.version = "(Build 1.0.3); 1/25/2007">
	<cfset application.syspath = replace(expandpath("*"),"\*","","ALL")>
	<cfset request.temppath = replace(replacenocase(application.syspath,expandpath("\"),"","all"),"\",".","ALL")>
	<cfset request.paths = listtoarray(application.syspath,"\")>
	<cfset request.thissub = request.paths[arraylen(request.paths)]>
	<cfset application.cfcpath = "#request.temppath#.">
	<cfset application.rootpage = "/#replace(application.cfcpath,".","/","ALL")#index.cfm">
	<cfset application.stats = arraynew(2)>
	<cfinclude template="conf/conf.cfm">
</cffunction>
	
<cffunction name="onRequestStart" returntype="Void"><cfsetting enablecfoutputonly="true" showdebugoutput="false">
	<cfif isdefined("application.mode") eq false or application.mode eq "development">
		<cfinclude template="conf/conf.cfm">
	</cfif>
<cfset application.mode = "development">
		<cfinvoke component="service.varimport" method="init">
		<cfparam name="request.method" default="display">
		<cfparam name="request.page" default="home">
		<cfparam name="request.pagename" default="#replace(request.page,"/","_","ALL")#">
		<cfparam name="request.thispage" default="">
		<cfparam name="request.error" default="">
		<cfparam name="request.position" default="1">
		<cfparam name="session.islogin" default="no">
		<cfparam name="session.loginattempts" default="0">
		<cfinvoke component="controller.prerequest" method="init">
		
	<cfif application.mode eq "development" or not isdefined("application.index")>
		<cfinvoke component="controller.page" method="load" returnvariable="application.index">
			<cfinvokeargument name="syspath" value="#application.syspath#">
		</cfinvoke>
	</cfif>
</cffunction>

<cffunction name="onRequest" returntype="Void">
	<cfinclude template="service/security.cfm">
	<cfif cgi.script_name eq application.rootpage>
		<cfif request.method eq "rss">
			<cfinclude template="view/rss.cfm">
		<cfelseif request.method eq "display">
			<cfinvoke component="controller.base" method="display" returnvariable="request.thispage">
			<cfinvoke component="#application.cfcpath#controller.page" method="recordhit" returnvariable="application.stats">
				<cfinvokeargument name="stats" value="#application.stats#">
				<cfinvokeargument name="page" value="#request.page#">
			</cfinvoke>
		<cfelse>
			<cfinvoke component="controller.base" method="other" returnvariable="request.thispage">
		</cfif>
		<cfoutput>#request.thispage#</cfoutput>
	<cfelseif cgi.script_name contains "FCKEditor">
		<cfif session.isLogin eq "yes">
			<cfinclude template="#cgi.script_name#">
		</cfif>
	<cfelseif cgi.script_name contains "plugins">
		<cfinclude template="#cgi.script_name#">
	</CFIF>
</cffunction>

<cffunction name="onRequestEnd" returntype="Void">
		<cfinvoke component="controller.postrequest" method="init">
</cffunction>

<cffunction name="onError">
	<cfargument name="exception" required="true">
	<cfargument name="eventName" type="String" required="true">
	<cfinclude template="errors/default.cfm">
</cffunction>



</cfcomponent>
