<cfcomponent output="false">

<cfscript>
function clearwhitespace(text){
		text = replace(text,"#chr(9)#","","ALL");
		text = replace(text,"#chr(13)#","","ALL");
		text = replace(text,"#chr(10)#","","ALL");
		text = stripCR(text);
		text = trim(text);
		return text;
	}
function cleanrss(text){
		text = urlencodedformat(text,application.charset);
		text = replace(text,"%20"," ","ALL");
		text = stripCR(text);
		text = trim(text);
		return text;
	}
function rfc822format(ts){
	dts = "#left(DayOfWeekAsString(dayofweek(ts)),3)#, ";
	if (day(ts) lt 10){
	dts = dts & "0#day(ts)# ";
	}else{
	dts = dts & "#day(ts)# ";
	}
	dts = dts & "#left(monthasstring(month(ts)),3)# ";
	dts = dts & "#year(ts)# ";
	dts = dts & "#timeformat(ts,"HH:mm:ss")# ";
	dts = dts & "#application.timezone#";
	return dts;
}
</cfscript>

<cffunction name="init" returntype="Void" output="false">
</cffunction>

<cffunction name="contents" returntype="string" output="false">
	<cfargument name="location" type="string" required="true">
	<cftry>
	<cffile action="read" file="#application.syspath#\pages\#location#.#application.pageext#" variable="contents" charset="#application.charset#">
	<!---Remove relative URLs--->
	<cfset contents = replace(contents,"src=""/#replace(application.cfcpath,".","","ALL")#","src=""http://#cgi.server_name#/#replace(application.cfcpath,".","","ALL")#","ALL")>
	<cfset contents = replace(contents,"href=""##","href=""http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#pages/#location#.#application.pageext###","ALL")>
	<cfset contents = replace(contents,"href=""/","href=""http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#","ALL")>
	<cfset contents = htmleditformat(contents)>
	<cfcatch><cfset contents = "Sorry, error in pulling this page."></cfcatch>
	</cftry>
	<cfreturn contents/>
</cffunction>

<cffunction name="build" returntype="string" output="false">

	<cfsavecontent variable="rss">
	<cfoutput>
		<?xml version="1.0" encoding="#application.charset#"?>
			
		<rss version="2.0">
		<channel>
		<title>#application.sitetitle# <cfif len(application.citystate)>- #application.citystate#</cfif></title>
		<link>http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#</link>
		<description>#application.sitedescription#</description>
		<language>#application.language#</language>
		<pubDate>#rfc822format(now())#</pubDate>
		<lastBuildDate>#rfc822format(now())#</lastBuildDate>
		<generator>Katapult</generator>
		<docs>http://blogs.law.harvard.edu/tech/rss</docs>
		<managingEditor>#application.email#</managingEditor>
		<webMaster>#application.email#</webMaster>

<cfloop from="1" to="#arraylen(application.index)#" index="f">
	<cfinvoke component="rss" method="contents" returnvariable="contents">
		<cfinvokeargument name="location" value="#application.index[f].location#">
	</cfinvoke>

		<item>
			<title>#cleanrss(application.index[f].page)#</title>
			<link>http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#</link>
			<guid isPermaLink="false">http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#</guid>
			<description>#contents#</description>
			<cfif len(application.categories)>
			<cfloop list="#application.categories#" index="subject">
			<category>#cleanrss(subject)#</category>
			</cfloop>
			</cfif>
			<category>#cleanrss(application.index[f].page)#</category>
			<pubDate>#rfc822format(application.index[f].datemodified)#</pubDate>
		</item>
<cfif arraylen(application.index[f].subpages)>
<cfloop from="1" to="#arraylen(application.index[f].subpages)#" index="s">
	<cfinvoke component="rss" method="contents" returnvariable="contents">
		<cfinvokeargument name="location" value="#application.index[f].location#/#application.index[f].subpages[s].location#">
	</cfinvoke>

		<item>
			<title>#cleanrss(application.index[f].subpages[s].page)#</title>
			<link>http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#</link>
			<guid isPermaLink="false">http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#</guid>
			<description>#contents#</description>
			<cfif len(application.categories)>
			<cfloop list="#application.categories#" index="subject">
			<category>#cleanrss(subject)#</category>
			</cfloop>
			</cfif>
			<category>#cleanrss(application.index[f].subpages[s].page)#</category>
			<category>#cleanrss(application.index[f].page)#</category>
			<pubDate>#rfc822format(application.index[f].subpages[s].datemodified)#</pubDate>
		</item>
<cfif arraylen(application.index[f].subpages[s].subpages)>
<cfloop from="1" to="#arraylen(application.index[f].subpages[s].subpages)#" index="t">
	<cfinvoke component="rss" method="contents" returnvariable="contents">
		<cfinvokeargument name="location" value="#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#">
	</cfinvoke>

		<item>
			<title>#cleanrss(application.index[f].subpages[s].subpages[t].page)#</title>
			<link>http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#</link>
			<guid isPermaLink="false">http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#</guid>
			<description>#contents#</description>
			<cfif len(application.categories)>
			<cfloop list="#application.categories#" index="subject">
			<category>#cleanrss(subject)#</category>
			</cfloop>
			</cfif>
			<category>#cleanrss(application.index[f].subpages[s].subpages[t].page)#</category>
			<category>#cleanrss(application.index[f].subpages[s].page)#</category>
			<category>#cleanrss(application.index[f].page)#</category>
			<pubDate>#rfc822format(application.index[f].subpages[s].subpages[t].datemodified)#</pubDate>
		</item>
<cfif arraylen(application.index[f].subpages[s].subpages[t].subpages)>
<cfloop from="1" to="#arraylen(application.index[f].subpages[s].subpages[t].subpages)#" index="h">
	<cfinvoke component="rss" method="contents" returnvariable="contents">
		<cfinvokeargument name="location" value="#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#/#application.index[f].subpages[s].subpages[t].subpages[h].location#">
	</cfinvoke>

		<item>
			<title>#cleanrss(application.index[f].subpages[s].subpages[t].subpages[h].page)#</title>
			<link>http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#/#application.index[f].subpages[s].subpages[t].subpages[h].location#</link>
			<guid isPermaLink="false">http://#cgi.server_name#/#replace(application.cfcpath,".","/","ALL")#index.cfm?page=#application.index[f].location#/#application.index[f].subpages[s].location#/#application.index[f].subpages[s].subpages[t].location#/#application.index[f].subpages[s].subpages[t].subpages[h].location#</guid>
			<description>#contents#</description>
			<cfif len(application.categories)>
			<cfloop list="#application.categories#" index="subject">
			<category>#cleanrss(subject)#</category>
			</cfloop>
			</cfif>
			<category>#cleanrss(application.index[f].subpages[s].subpages[t].subpages[h].page)#</category>
			<category>#cleanrss(application.index[f].subpages[s].subpages[t].page)#</category>
			<category>#cleanrss(application.index[f].subpages[s].page)#</category>
			<category>#cleanrss(application.index[f].page)#</category>
			<pubDate>#rfc822format(application.index[f].subpages[s].subpages[t].subpages[h].datemodified)#</pubDate>
		</item>
</cfloop>
</cfif>
</cfloop>
</cfif>
</cfloop>
</cfif>
</cfloop>

		</channel>
		</rss>
	</cfoutput>
	</cfsavecontent>

	<cfset rss = clearwhitespace(rss)>

	<cfreturn rss/>
</cffunction>

</cfcomponent>